/*
 * 1.1 Swing version.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/* 
 * Based on Arthur van Hoff's animation examples, this applet
 * can serve as a template for all animation applets.
 */

public class AnimatorAppletTimer extends JApplet 
                            implements ActionListener {

    AnimTimer animTimer;
    int frameNumber = -1;
    int delay;
    boolean frozen = false;
    Timer timer;
    int fps;

    public void init() {

        animTimer = new AnimTimer();

        String str;

        //How many milliseconds between frames?  
        str = getParameter("fps");
        try { 
            if (str != null) {
                fps = Integer.parseInt(str);
            }
        } catch (Exception e) {}

        delay = (fps > 0) ? (1000 / fps) : 100;

        timer = new Timer(delay, this);
        timer.setInitialDelay(0);
        timer.setCoalesce(true);

        getContentPane().add(animTimer);

        addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                if (frozen) {
                    frozen = false;
                    startAnimation();
                } else {
                    frozen = true;
                    stopAnimation();
                }
            }
       });
       startAnimation();

    }


    public void startAnimation() {
        if (frozen) { 
            //Do nothing.  The user has requested that we 
            //stop changing the image.
        } else {
            //Start animating!
            timer.start();
        }
    }

    public void stopAnimation() {
        //Stop the animating thread.
        timer.stop();
    }

    public void actionPerformed(ActionEvent e) {
        //Advance the animation frame.
        frameNumber++;
        repaint();
    }

class AnimTimer extends JPanel {

    public AnimTimer() {}
   
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawString("Frame " + frameNumber, 0, 30);
    }
}

}
